//
// AttributeAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



public class AttributeAPI: APIBase {
    /**
     creates a new attribute
     
     - parameter attribute: (body) the data to save 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func createAttribute(attribute attribute: AttributePost, completion: ((data: ApiResponsePost?, error: ErrorType?) -> Void)) {
        createAttributeWithRequestBuilder(attribute: attribute).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     creates a new attribute
     - POST /attributes
     - creates a new attribute.
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "id" : "aeiou"
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter attribute: (body) the data to save 

     - returns: RequestBuilder<ApiResponsePost> 
     */
    public class func createAttributeWithRequestBuilder(attribute attribute: AttributePost) -> RequestBuilder<ApiResponsePost> {
        let path = "/attributes"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = attribute.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ApiResponsePost>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     delete the attribute
     
     - parameter lid: (path) the id of the list 
     - parameter id: (path) the id of the attribute 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func deleteAttribute(lid lid: String, id: String, completion: ((data: ApiResponseDelete?, error: ErrorType?) -> Void)) {
        deleteAttributeWithRequestBuilder(lid: lid, id: id).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     delete the attribute
     - DELETE /lists/{lid}/attributes/{id}
     - delete one attribute
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={ }}]
     
     - parameter lid: (path) the id of the list 
     - parameter id: (path) the id of the attribute 

     - returns: RequestBuilder<ApiResponseDelete> 
     */
    public class func deleteAttributeWithRequestBuilder(lid lid: String, id: String) -> RequestBuilder<ApiResponseDelete> {
        var path = "/lists/{lid}/attributes/{id}"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{id}", withString: "\(id)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ApiResponseDelete>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     get all Attributes of selected list
     
     - parameter lid: (path) the id of the list 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func getAttributes(lid lid: String, filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil, completion: ((data: AttributeResponse?, error: ErrorType?) -> Void)) {
        getAttributesWithRequestBuilder(lid: lid, filter: filter, limit: limit, offset: offset, expand: expand, fields: fields).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     get all Attributes of selected list
     - GET /lists/{lid}/attributes
     - get Attributes
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "sub_type" : "aeiou",
    "name" : "aeiou",
    "id" : "aeiou",
    "type" : "aeiou"
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

     - returns: RequestBuilder<AttributeResponse> 
     */
    public class func getAttributesWithRequestBuilder(lid lid: String, filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil) -> RequestBuilder<AttributeResponse> {
        var path = "/lists/{lid}/attributes"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter,
            "_limit": limit?.encodeToJSON(),
            "_offset": offset?.encodeToJSON(),
            "_expand": expand,
            "_fields": fields
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<AttributeResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     update the attribute
     
     - parameter id: (path) the id of the attribute 
     - parameter attribute: (body) the data to update 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func updateAttribute(id id: String, attribute: AttributePatch, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        updateAttributeWithRequestBuilder(id: id, attribute: attribute).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     update the attribute
     - PATCH /attributes/{id}
     - update one attribute
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter id: (path) the id of the attribute 
     - parameter attribute: (body) the data to update 

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func updateAttributeWithRequestBuilder(id id: String, attribute: AttributePatch) -> RequestBuilder<PatchResponse> {
        var path = "/attributes/{id}"
        path = path.stringByReplacingOccurrencesOfString("{id}", withString: "\(id)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = attribute.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PATCH", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

}
