//
// AuthorizationAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



public class AuthorizationAPI: APIBase {
    /**

    enum for parameter grantType
    */
    public enum GrantType_getToken: String { 
        case Https//nl2go.com/jwt = "https://nl2go.com/jwt"
        case Https//nl2go.com/jwtRefresh = "https://nl2go.com/jwt_refresh"
    }

    /**
     Endpoint for retrieving a token
     
     - parameter grantType: (form) grant_type 
     - parameter username: (form) username. Required for grant_type https://nl2go.com/jwt (optional)
     - parameter password: (form) password. Required for grant_type https://nl2go.com/jwt (optional)
     - parameter refreshToken: (form) refresh_token. Required for grant_type https://nl2go.com/jwt_refresh (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func getToken(grantType grantType: GrantType_getToken, username: String? = nil, password: String? = nil, refreshToken: String? = nil, completion: ((data: Token?, error: ErrorType?) -> Void)) {
        getTokenWithRequestBuilder(grantType: grantType, username: username, password: password, refreshToken: refreshToken).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Endpoint for retrieving a token
     - POST /oauth/v2/token
     - The Newsletter2Go API uses Basic Authorization for authentication. <br/>First, you will need to find your API credentials in your Newsletter2Go account by navigating to Account > API. You need the auth key, your user name and your password to use our API. <br/>We recommend that you create a dedicated user before you get started. This way, you can better manage permissions without account your account and do not have to worry about password changes. <br/>In order to make API calls you need to pass an access token in each request.<br/>To acquire this access token, first make a POST call to our oauth end point: {{/oauth/v2/token}}<br/>Make sure to pass your crendentials and our grant_type in the body (either as formData or as JSON. In the latter case, submit Content-Type: application/json in the header)<br/>(We will use JavaScript examples here - see our example implementations for other programming languages)<br/><code>var params = {<br/>&nbsp;&nbsp;\"username\": \"your@email.com\",<br/>&nbsp;&nbsp;\"grant_type\": \"https://nl2go.com/jwt\",<br/>&nbsp;&nbsp;\"password\": \"your_password\"<br/>}</code><br/>and add an Authorization header with your auth key:<br/><code>xhr.setRequestHeader(\"Authorization\", \"Basic \" + btoa(\"xhr5n6xf_Rtguwv_jzr1d3_LTshikn4_0dtesdahNvp1:Kqf2Hs#Wwazl\");</code><br/>send the request:<br/><code>xhr.send(JSON.stringify(params));</code><br/>and the API will return the access_token (valid for 120 minutes) and a refresh_token that you can use to create a new access_token after the first one has expired.<br/><code>{<br/>&nbsp;&nbsp;\"access_token\": \"string\",<br/>&nbsp;&nbsp;\"expires_in\": 0,<br/>&nbsp;&nbsp;\"token_type\": \"string\",<br/>&nbsp;&nbsp;\"refresh_token\": \"string\"<br/>}</code><br/>Make sure to save the access_token - you will need it for every following call that you make.
     - BASIC:
       - type: basic
       - name: Basic
     - examples: [{contentType=application/json, example={
  "access_token" : "aeiou",
  "refresh_token" : "aeiou",
  "token_type" : "aeiou",
  "expires_in" : ""
}}]
     
     - parameter grantType: (form) grant_type 
     - parameter username: (form) username. Required for grant_type https://nl2go.com/jwt (optional)
     - parameter password: (form) password. Required for grant_type https://nl2go.com/jwt (optional)
     - parameter refreshToken: (form) refresh_token. Required for grant_type https://nl2go.com/jwt_refresh (optional)

     - returns: RequestBuilder<Token> 
     */
    public class func getTokenWithRequestBuilder(grantType grantType: GrantType_getToken, username: String? = nil, password: String? = nil, refreshToken: String? = nil) -> RequestBuilder<Token> {
        let path = "/oauth/v2/token"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "username": username,
            "password": password,
            "refresh_token": refreshToken,
            "grant_type": grantType
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Token>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

}
