//
// CompanyAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



public class CompanyAPI: APIBase {
    /**
     get the details of a company
     
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func getCompany(completion: ((data: CompanyResponse?, error: ErrorType?) -> Void)) {
        getCompanyWithRequestBuilder().execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     get the details of a company
     - GET /companies
     - get the details of a company
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "bill_city" : "aeiou",
    "credits_email" : "",
    "credits_freemail" : "",
    "country" : "aeiou",
    "bill_postcode" : "aeiou",
    "address" : "aeiou",
    "city" : "aeiou",
    "bill_first_name" : "aeiou",
    "postcode" : "aeiou",
    "bill_name" : "aeiou",
    "bill_last_name" : "aeiou",
    "bill_address" : "aeiou",
    "bill_country" : "aeiou",
    "credits_abo" : "",
    "name" : "aeiou",
    "default_list_id" : "aeiou",
    "id" : "aeiou",
    "state" : "aeiou"
  } ],
  "info" : {
    "count" : ""
  }
}}]

     - returns: RequestBuilder<CompanyResponse> 
     */
    public class func getCompanyWithRequestBuilder() -> RequestBuilder<CompanyResponse> {
        let path = "/companies"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<CompanyResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     update the Company
     
     - parameter id: (path) the id of the Company 
     - parameter company: (body) the data to update 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func updateCompany(id id: String, company: CompanyPatch, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        updateCompanyWithRequestBuilder(id: id, company: company).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     update the Company
     - PATCH /companies/{id}
     - update the Company
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter id: (path) the id of the Company 
     - parameter company: (body) the data to update 

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func updateCompanyWithRequestBuilder(id id: String, company: CompanyPatch) -> RequestBuilder<PatchResponse> {
        var path = "/companies/{id}"
        path = path.stringByReplacingOccurrencesOfString("{id}", withString: "\(id)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = company.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PATCH", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

}
