//
// ListAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



public class ListAPI: APIBase {
    /**
     creates a new list
     
     - parameter list: (body) the data to save 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func createList(list list: ListPost, completion: ((data: ApiResponsePost?, error: ErrorType?) -> Void)) {
        createListWithRequestBuilder(list: list).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     creates a new list
     - POST /lists
     - creates a new List
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "id" : "aeiou"
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter list: (body) the data to save 

     - returns: RequestBuilder<ApiResponsePost> 
     */
    public class func createListWithRequestBuilder(list list: ListPost) -> RequestBuilder<ApiResponsePost> {
        let path = "/lists"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = list.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ApiResponsePost>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     delete the List
     
     - parameter id: (path) the id of the list 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func deleteList(id id: String, completion: ((data: ApiResponseDelete?, error: ErrorType?) -> Void)) {
        deleteListWithRequestBuilder(id: id).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     delete the List
     - DELETE /lists/{id}
     - delete one List
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={ }}]
     
     - parameter id: (path) the id of the list 

     - returns: RequestBuilder<ApiResponseDelete> 
     */
    public class func deleteListWithRequestBuilder(id id: String) -> RequestBuilder<ApiResponseDelete> {
        var path = "/lists/{id}"
        path = path.stringByReplacingOccurrencesOfString("{id}", withString: "\(id)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ApiResponseDelete>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     get all lists
     
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func getLists(filter filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil, completion: ((data: ListResponse?, error: ErrorType?) -> Void)) {
        getListsWithRequestBuilder(filter: filter, limit: limit, offset: offset, expand: expand, fields: fields).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     get all lists
     - GET /lists
     - get Lists
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "imprint" : "aeiou",
    "header_from_name" : "aeiou",
    "header_reply_email" : "aeiou",
    "has_opentracking" : true,
    "has_clicktracking" : true,
    "header_reply_name" : "aeiou",
    "has_conversiontracking" : true,
    "uses_econda" : true,
    "name" : "aeiou",
    "id" : "aeiou",
    "uses_googleanalytics" : true,
    "header_from_email" : "aeiou",
    "tracking_url" : "aeiou"
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

     - returns: RequestBuilder<ListResponse> 
     */
    public class func getListsWithRequestBuilder(filter filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil) -> RequestBuilder<ListResponse> {
        let path = "/lists"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter,
            "_limit": limit?.encodeToJSON(),
            "_offset": offset?.encodeToJSON(),
            "_expand": expand,
            "_fields": fields
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ListResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     get all Recipients of selected list
     
     - parameter lid: (path) the id of the list 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func getRecipients(lid lid: String, filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil, completion: ((data: RecipientResponse?, error: ErrorType?) -> Void)) {
        getRecipientsWithRequestBuilder(lid: lid, filter: filter, limit: limit, offset: offset, expand: expand, fields: fields).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     get all Recipients of selected list
     - GET /lists/{lid}/recipients
     - Get Recipients. If the API shall return custom attributes also, submit them in the _fields-Parameter by name.
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "statistic_last_mail_converted" : "2000-01-23T04:56:07.000+0000",
    "statistic_last_useragent_device" : "aeiou",
    "gender" : "aeiou",
    "statistic_last_unsubscribe_list" : "2000-01-23T04:56:07.000+0000",
    "rating" : "",
    "statistic_mails_clicked" : "",
    "statistic_last_longitude" : 1.3579000000000001069366817318950779736042022705078125,
    "statistic_mails_opened" : "",
    "statistic_last_blacklist_list_reason" : "aeiou",
    "id" : "aeiou",
    "first_name" : "aeiou",
    "email" : "aeiou",
    "_custom_attribute_" : "aeiou",
    "statistic_last_useragent_family" : "aeiou",
    "statistic_last_blacklist_list" : "2000-01-23T04:56:07.000+0000",
    "statistic_last_mail_received" : "2000-01-23T04:56:07.000+0000",
    "statistic_conversions_sum" : 1.3579000000000001069366817318950779736042022705078125,
    "is_unsubscribed" : true,
    "statistic_last_mail_action" : "2000-01-23T04:56:07.000+0000",
    "statistic_last_unsubscribe_list_reason" : "aeiou",
    "last_name" : "aeiou",
    "is_blacklisted" : true,
    "statistic_conversions" : "",
    "statistic_last_mail_clicked" : "2000-01-23T04:56:07.000+0000",
    "statistic_last_latitude" : 1.3579000000000001069366817318950779736042022705078125,
    "phone" : "aeiou",
    "statistic_last_mail_opened" : "2000-01-23T04:56:07.000+0000",
    "statistic_mails_received" : "",
    "statistic_mails_unique_opened" : ""
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

     - returns: RequestBuilder<RecipientResponse> 
     */
    public class func getRecipientsWithRequestBuilder(lid lid: String, filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil) -> RequestBuilder<RecipientResponse> {
        var path = "/lists/{lid}/recipients"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter,
            "_limit": limit?.encodeToJSON(),
            "_offset": offset?.encodeToJSON(),
            "_expand": expand,
            "_fields": fields
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<RecipientResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     remove all Recipients from selected list
     
     - parameter lid: (path) the id of the list 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func removeRecipientsFromList(lid lid: String, filter: String? = nil, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        removeRecipientsFromListWithRequestBuilder(lid: lid, filter: filter).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     remove all Recipients from selected list
     - DELETE /lists/{lid}/recipients
     - remove Recipients from selected list. Pay attention to the filter, if you forget to submit it, all recipients of the current list are getting removed!
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter filter: (query) a FIQL-Filter (optional)

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func removeRecipientsFromListWithRequestBuilder(lid lid: String, filter: String? = nil) -> RequestBuilder<PatchResponse> {
        var path = "/lists/{lid}/recipients"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     update the List
     
     - parameter id: (path) the id of the list 
     - parameter list: (body) the data to update 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func updateList(id id: String, list: ListPost, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        updateListWithRequestBuilder(id: id, list: list).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     update the List
     - PATCH /lists/{id}
     - update one List
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter id: (path) the id of the list 
     - parameter list: (body) the data to update 

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func updateListWithRequestBuilder(id id: String, list: ListPost) -> RequestBuilder<PatchResponse> {
        var path = "/lists/{id}"
        path = path.stringByReplacingOccurrencesOfString("{id}", withString: "\(id)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = list.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PATCH", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     update all Recipients in selected list
     
     - parameter lid: (path) the id of the list 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func updateRecipients(lid lid: String, filter: String? = nil, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        updateRecipientsWithRequestBuilder(lid: lid, filter: filter).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     update all Recipients in selected list
     - PATCH /lists/{lid}/recipients
     - Updates all recipients in the given list where the filter applies. If a value of a custom attribute shall by changed just submit it in the json body. Pay attention to the filter, if you forget to submit it, all recipients of the current list are getting updated!
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter filter: (query) a FIQL-Filter (optional)

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func updateRecipientsWithRequestBuilder(lid lid: String, filter: String? = nil) -> RequestBuilder<PatchResponse> {
        var path = "/lists/{lid}/recipients"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PATCH", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

}
