//
// UserAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



public class UserAPI: APIBase {
    /**
     get all users of the company where the current user has access to
     
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func getUsers(filter filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil, completion: ((data: UserResponse?, error: ErrorType?) -> Void)) {
        getUsersWithRequestBuilder(filter: filter, limit: limit, offset: offset, expand: expand, fields: fields).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     get all users of the company where the current user has access to
     - GET /users
     - get Users
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "is_active" : true,
    "gender" : "aeiou",
    "last_name" : "aeiou",
    "id" : "aeiou",
    "first_name" : "aeiou",
    "email" : "aeiou"
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

     - returns: RequestBuilder<UserResponse> 
     */
    public class func getUsersWithRequestBuilder(filter filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil) -> RequestBuilder<UserResponse> {
        let path = "/users"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter,
            "_limit": limit?.encodeToJSON(),
            "_offset": offset?.encodeToJSON(),
            "_expand": expand,
            "_fields": fields
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<UserResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     update the user
     
     - parameter id: (path) the id of the user 
     - parameter user: (body) the data to update 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func updateUser(id id: String, user: UserPatch, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        updateUserWithRequestBuilder(id: id, user: user).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     update the user
     - PATCH /users/{id}
     - update one user
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter id: (path) the id of the user 
     - parameter user: (body) the data to update 

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func updateUserWithRequestBuilder(id id: String, user: UserPatch) -> RequestBuilder<PatchResponse> {
        var path = "/users/{id}"
        path = path.stringByReplacingOccurrencesOfString("{id}", withString: "\(id)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = user.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PATCH", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

}
