// Models.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation

protocol JSONEncodable {
    func encodeToJSON() -> AnyObject
}

public class Response<T> {
    public let statusCode: Int
    public let header: [String: String]
    public let body: T

    public init(statusCode: Int, header: [String: String], body: T) {
        self.statusCode = statusCode
        self.header = header
        self.body = body
    }

    public convenience init(response: NSHTTPURLResponse, body: T) {
        let rawHeader = response.allHeaderFields
        var header = [String:String]()
        for (key, value) in rawHeader {
            header[key as! String] = value as? String
        }
        self.init(statusCode: response.statusCode, header: header, body: body)
    }
}

private var once = dispatch_once_t()
class Decoders {
    static private var decoders = Dictionary<String, ((AnyObject) -> AnyObject)>()
    
    static func addDecoder<T>(clazz clazz: T.Type, decoder: ((AnyObject) -> T)) {
        let key = "\(T.self)"
        decoders[key] = { decoder($0) as! AnyObject }
    }
    
    static func decode<T>(clazz clazz: [T].Type, source: AnyObject) -> [T] {
        let array = source as! [AnyObject]
        return array.map { Decoders.decode(clazz: T.self, source: $0) }
    }
    
    static func decode<T, Key: Hashable>(clazz clazz: [Key:T].Type, source: AnyObject) -> [Key:T] {
        let sourceDictionary = source as! [Key: AnyObject]
        var dictionary = [Key:T]()
        for (key, value) in sourceDictionary {
            dictionary[key] = Decoders.decode(clazz: T.self, source: value)
        }
        return dictionary
    }
    
    static func decode<T>(clazz clazz: T.Type, source: AnyObject) -> T {
        initialize()
        if T.self is Int32.Type && source is NSNumber {
            return source.intValue as! T;
        }
        if T.self is Int64.Type && source is NSNumber {
            return source.longLongValue as! T;
        }
        if source is T {
            return source as! T
        }
        
        let key = "\(T.self)"
        if let decoder = decoders[key] {
           return decoder(source) as! T
        } else {
            fatalError("Source \(source) is not convertible to type \(clazz): Maybe swagger file is insufficient")
        }
    }

    static func decodeOptional<T>(clazz clazz: T.Type, source: AnyObject?) -> T? {
        if source is NSNull {
            return nil
        }
        return source.map { (source: AnyObject) -> T in
            Decoders.decode(clazz: clazz, source: source)
        }
    }

    static func decodeOptional<T>(clazz clazz: [T].Type, source: AnyObject?) -> [T]? {
        if source is NSNull {
            return nil
        }
        return source.map { (someSource: AnyObject) -> [T] in
            Decoders.decode(clazz: clazz, source: someSource)
        }
    }

    static func decodeOptional<T, Key: Hashable>(clazz clazz: [Key:T].Type, source: AnyObject?) -> [Key:T]? {
        if source is NSNull {
            return nil
        }
        return source.map { (someSource: AnyObject) -> [Key:T] in
            Decoders.decode(clazz: clazz, source: someSource)
        }
    }
	
    static private func initialize() {
        dispatch_once(&once) {
            let formatters = [
                "yyyy-MM-dd",
                "yyyy-MM-dd'T'HH:mm:ssZZZZZ",
                "yyyy-MM-dd'T'HH:mm:ss.SSSZZZZZ",
                "yyyy-MM-dd'T'HH:mm:ss'Z'"
            ].map { (format: String) -> NSDateFormatter in
                let formatter = NSDateFormatter()
                formatter.dateFormat = format
                return formatter
            }
            // Decoder for NSDate
            Decoders.addDecoder(clazz: NSDate.self) { (source: AnyObject) -> NSDate in
               if let sourceString = source as? String {
                    for formatter in formatters {
                        if let date = formatter.dateFromString(sourceString) {
                            return date
                        }
                    }
                
                }
                if let sourceInt = source as? Int {
                    // treat as a java date
                    return NSDate(timeIntervalSince1970: Double(sourceInt / 1000) )
                }
                fatalError("formatter failed to parse \(source)")
            } 

            // Decoder for [ApiResponseDelete]
            Decoders.addDecoder(clazz: [ApiResponseDelete].self) { (source: AnyObject) -> [ApiResponseDelete] in
                return Decoders.decode(clazz: [ApiResponseDelete].self, source: source)
            }
            // Decoder for ApiResponseDelete
            Decoders.addDecoder(clazz: ApiResponseDelete.self) { (source: AnyObject) -> ApiResponseDelete in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = ApiResponseDelete()
                return instance
            }


            // Decoder for [ApiResponsePost]
            Decoders.addDecoder(clazz: [ApiResponsePost].self) { (source: AnyObject) -> [ApiResponsePost] in
                return Decoders.decode(clazz: [ApiResponsePost].self, source: source)
            }
            // Decoder for ApiResponsePost
            Decoders.addDecoder(clazz: ApiResponsePost.self) { (source: AnyObject) -> ApiResponsePost in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = ApiResponsePost()
                instance.info = Decoders.decodeOptional(clazz: Info.self, source: sourceDictionary["info"])
                instance.value = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["value"])
                return instance
            }


            // Decoder for [AttributeGet]
            Decoders.addDecoder(clazz: [AttributeGet].self) { (source: AnyObject) -> [AttributeGet] in
                return Decoders.decode(clazz: [AttributeGet].self, source: source)
            }
            // Decoder for AttributeGet
            Decoders.addDecoder(clazz: AttributeGet.self) { (source: AnyObject) -> AttributeGet in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = AttributeGet()
                instance.id = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["id"])
                instance.name = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["name"])
                instance.type = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["type"])
                instance.subType = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["sub_type"])
                return instance
            }


            // Decoder for [AttributePatch]
            Decoders.addDecoder(clazz: [AttributePatch].self) { (source: AnyObject) -> [AttributePatch] in
                return Decoders.decode(clazz: [AttributePatch].self, source: source)
            }
            // Decoder for AttributePatch
            Decoders.addDecoder(clazz: AttributePatch.self) { (source: AnyObject) -> AttributePatch in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = AttributePatch()
                instance.listIds = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["list_ids"])
                instance.name = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["name"])
                return instance
            }


            // Decoder for [AttributePost]
            Decoders.addDecoder(clazz: [AttributePost].self) { (source: AnyObject) -> [AttributePost] in
                return Decoders.decode(clazz: [AttributePost].self, source: source)
            }
            // Decoder for AttributePost
            Decoders.addDecoder(clazz: AttributePost.self) { (source: AnyObject) -> AttributePost in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = AttributePost()
                instance.listIds = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["list_ids"])
                instance.name = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["name"])
                instance.type = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["type"])
                instance.subType = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["sub_type"])
                return instance
            }


            // Decoder for [AttributeResponse]
            Decoders.addDecoder(clazz: [AttributeResponse].self) { (source: AnyObject) -> [AttributeResponse] in
                return Decoders.decode(clazz: [AttributeResponse].self, source: source)
            }
            // Decoder for AttributeResponse
            Decoders.addDecoder(clazz: AttributeResponse.self) { (source: AnyObject) -> AttributeResponse in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = AttributeResponse()
                instance.info = Decoders.decodeOptional(clazz: Info.self, source: sourceDictionary["info"])
                instance.value = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["value"])
                return instance
            }


            // Decoder for [CompanyGet]
            Decoders.addDecoder(clazz: [CompanyGet].self) { (source: AnyObject) -> [CompanyGet] in
                return Decoders.decode(clazz: [CompanyGet].self, source: source)
            }
            // Decoder for CompanyGet
            Decoders.addDecoder(clazz: CompanyGet.self) { (source: AnyObject) -> CompanyGet in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = CompanyGet()
                instance.id = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["id"])
                instance.name = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["name"])
                instance.address = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["address"])
                instance.city = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["city"])
                instance.postcode = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["postcode"])
                instance.country = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["country"])
                instance.billName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["bill_name"])
                instance.billFirstName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["bill_first_name"])
                instance.billLastName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["bill_last_name"])
                instance.billAddress = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["bill_address"])
                instance.billCity = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["bill_city"])
                instance.billPostcode = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["bill_postcode"])
                instance.billCountry = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["bill_country"])
                instance.defaultListId = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["default_list_id"])
                instance.state = CompanyGet.State(rawValue: (sourceDictionary["state"] as? String) ?? "") 
                instance.creditsEmail = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["credits_email"])
                instance.creditsFreemail = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["credits_freemail"])
                instance.creditsAbo = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["credits_abo"])
                return instance
            }


            // Decoder for [CompanyPatch]
            Decoders.addDecoder(clazz: [CompanyPatch].self) { (source: AnyObject) -> [CompanyPatch] in
                return Decoders.decode(clazz: [CompanyPatch].self, source: source)
            }
            // Decoder for CompanyPatch
            Decoders.addDecoder(clazz: CompanyPatch.self) { (source: AnyObject) -> CompanyPatch in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = CompanyPatch()
                instance.name = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["name"])
                instance.address = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["address"])
                instance.city = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["city"])
                instance.postcode = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["postcode"])
                instance.country = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["country"])
                instance.billName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["bill_name"])
                instance.billFirstName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["bill_first_name"])
                instance.billLastName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["bill_last_name"])
                instance.billAddress = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["bill_address"])
                instance.billCity = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["bill_city"])
                instance.billPostcode = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["bill_postcode"])
                instance.billCountry = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["bill_country"])
                instance.defaultListId = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["default_list_id"])
                return instance
            }


            // Decoder for [CompanyResponse]
            Decoders.addDecoder(clazz: [CompanyResponse].self) { (source: AnyObject) -> [CompanyResponse] in
                return Decoders.decode(clazz: [CompanyResponse].self, source: source)
            }
            // Decoder for CompanyResponse
            Decoders.addDecoder(clazz: CompanyResponse.self) { (source: AnyObject) -> CompanyResponse in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = CompanyResponse()
                instance.info = Decoders.decodeOptional(clazz: Info.self, source: sourceDictionary["info"])
                instance.value = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["value"])
                return instance
            }


            // Decoder for [Data]
            Decoders.addDecoder(clazz: [Data].self) { (source: AnyObject) -> [Data] in
                return Decoders.decode(clazz: [Data].self, source: source)
            }
            // Decoder for Data
            Decoders.addDecoder(clazz: Data.self) { (source: AnyObject) -> Data in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = Data()
                instance.file = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["file"])
                instance.associations = Decoders.decodeOptional(clazz: AnyObject.self, source: sourceDictionary["associations"])
                return instance
            }


            // Decoder for [Error]
            Decoders.addDecoder(clazz: [Error].self) { (source: AnyObject) -> [Error] in
                return Decoders.decode(clazz: [Error].self, source: source)
            }
            // Decoder for Error
            Decoders.addDecoder(clazz: Error.self) { (source: AnyObject) -> Error in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = Error()
                instance.status = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["status"])
                instance.code = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["code"])
                instance.errorMessage = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["errorMessage"])
                return instance
            }


            // Decoder for [GroupGet]
            Decoders.addDecoder(clazz: [GroupGet].self) { (source: AnyObject) -> [GroupGet] in
                return Decoders.decode(clazz: [GroupGet].self, source: source)
            }
            // Decoder for GroupGet
            Decoders.addDecoder(clazz: GroupGet.self) { (source: AnyObject) -> GroupGet in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = GroupGet()
                instance.id = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["id"])
                instance.name = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["name"])
                instance.description = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["description"])
                instance.listId = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["list_id"])
                return instance
            }


            // Decoder for [GroupPatch]
            Decoders.addDecoder(clazz: [GroupPatch].self) { (source: AnyObject) -> [GroupPatch] in
                return Decoders.decode(clazz: [GroupPatch].self, source: source)
            }
            // Decoder for GroupPatch
            Decoders.addDecoder(clazz: GroupPatch.self) { (source: AnyObject) -> GroupPatch in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = GroupPatch()
                instance.name = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["name"])
                instance.description = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["description"])
                return instance
            }


            // Decoder for [GroupPost]
            Decoders.addDecoder(clazz: [GroupPost].self) { (source: AnyObject) -> [GroupPost] in
                return Decoders.decode(clazz: [GroupPost].self, source: source)
            }
            // Decoder for GroupPost
            Decoders.addDecoder(clazz: GroupPost.self) { (source: AnyObject) -> GroupPost in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = GroupPost()
                instance.name = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["name"])
                instance.description = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["description"])
                instance.listId = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["list_id"])
                return instance
            }


            // Decoder for [GroupResponse]
            Decoders.addDecoder(clazz: [GroupResponse].self) { (source: AnyObject) -> [GroupResponse] in
                return Decoders.decode(clazz: [GroupResponse].self, source: source)
            }
            // Decoder for GroupResponse
            Decoders.addDecoder(clazz: GroupResponse.self) { (source: AnyObject) -> GroupResponse in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = GroupResponse()
                instance.info = Decoders.decodeOptional(clazz: Info.self, source: sourceDictionary["info"])
                instance.value = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["value"])
                return instance
            }


            // Decoder for [ImportGet]
            Decoders.addDecoder(clazz: [ImportGet].self) { (source: AnyObject) -> [ImportGet] in
                return Decoders.decode(clazz: [ImportGet].self, source: source)
            }
            // Decoder for ImportGet
            Decoders.addDecoder(clazz: ImportGet.self) { (source: AnyObject) -> ImportGet in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = ImportGet()
                instance.countInserted = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["count_inserted"])
                instance.countUpdated = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["count_updated"])
                instance.countFailed = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["count_failed"])
                instance.duplicateRecipients = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["duplicate_recipients"])
                instance.invalidRecipients = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["invalid_recipients"])
                return instance
            }


            // Decoder for [ImportResponse]
            Decoders.addDecoder(clazz: [ImportResponse].self) { (source: AnyObject) -> [ImportResponse] in
                return Decoders.decode(clazz: [ImportResponse].self, source: source)
            }
            // Decoder for ImportResponse
            Decoders.addDecoder(clazz: ImportResponse.self) { (source: AnyObject) -> ImportResponse in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = ImportResponse()
                instance.info = Decoders.decodeOptional(clazz: Info.self, source: sourceDictionary["info"])
                instance.value = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["value"])
                return instance
            }


            // Decoder for [Info]
            Decoders.addDecoder(clazz: [Info].self) { (source: AnyObject) -> [Info] in
                return Decoders.decode(clazz: [Info].self, source: source)
            }
            // Decoder for Info
            Decoders.addDecoder(clazz: Info.self) { (source: AnyObject) -> Info in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = Info()
                instance.count = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["count"])
                return instance
            }


            // Decoder for [InlineResponse200]
            Decoders.addDecoder(clazz: [InlineResponse200].self) { (source: AnyObject) -> [InlineResponse200] in
                return Decoders.decode(clazz: [InlineResponse200].self, source: source)
            }
            // Decoder for InlineResponse200
            Decoders.addDecoder(clazz: InlineResponse200.self) { (source: AnyObject) -> InlineResponse200 in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = InlineResponse200()
                instance.success = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["success"])
                instance.file = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["file"])
                return instance
            }


            // Decoder for [ListGet]
            Decoders.addDecoder(clazz: [ListGet].self) { (source: AnyObject) -> [ListGet] in
                return Decoders.decode(clazz: [ListGet].self, source: source)
            }
            // Decoder for ListGet
            Decoders.addDecoder(clazz: ListGet.self) { (source: AnyObject) -> ListGet in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = ListGet()
                instance.id = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["id"])
                instance.name = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["name"])
                instance.usesEconda = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["uses_econda"])
                instance.usesGoogleanalytics = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["uses_googleanalytics"])
                instance.hasOpentracking = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["has_opentracking"])
                instance.hasClicktracking = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["has_clicktracking"])
                instance.hasConversiontracking = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["has_conversiontracking"])
                instance.imprint = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["imprint"])
                instance.headerFromEmail = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["header_from_email"])
                instance.headerFromName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["header_from_name"])
                instance.headerReplyEmail = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["header_reply_email"])
                instance.headerReplyName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["header_reply_name"])
                instance.trackingUrl = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["tracking_url"])
                return instance
            }


            // Decoder for [ListPost]
            Decoders.addDecoder(clazz: [ListPost].self) { (source: AnyObject) -> [ListPost] in
                return Decoders.decode(clazz: [ListPost].self, source: source)
            }
            // Decoder for ListPost
            Decoders.addDecoder(clazz: ListPost.self) { (source: AnyObject) -> ListPost in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = ListPost()
                instance.name = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["name"])
                instance.usesEconda = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["uses_econda"])
                instance.usesGoogleanalytics = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["uses_googleanalytics"])
                instance.hasOpentracking = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["has_opentracking"])
                instance.hasClicktracking = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["has_clicktracking"])
                instance.hasConversiontracking = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["has_conversiontracking"])
                instance.imprint = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["imprint"])
                instance.headerFromEmail = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["header_from_email"])
                instance.headerFromName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["header_from_name"])
                instance.headerReplyEmail = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["header_reply_email"])
                instance.headerReplyName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["header_reply_name"])
                instance.trackingUrl = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["tracking_url"])
                return instance
            }


            // Decoder for [ListResponse]
            Decoders.addDecoder(clazz: [ListResponse].self) { (source: AnyObject) -> [ListResponse] in
                return Decoders.decode(clazz: [ListResponse].self, source: source)
            }
            // Decoder for ListResponse
            Decoders.addDecoder(clazz: ListResponse.self) { (source: AnyObject) -> ListResponse in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = ListResponse()
                instance.info = Decoders.decodeOptional(clazz: Info.self, source: sourceDictionary["info"])
                instance.value = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["value"])
                return instance
            }


            // Decoder for [ModelWithId]
            Decoders.addDecoder(clazz: [ModelWithId].self) { (source: AnyObject) -> [ModelWithId] in
                return Decoders.decode(clazz: [ModelWithId].self, source: source)
            }
            // Decoder for ModelWithId
            Decoders.addDecoder(clazz: ModelWithId.self) { (source: AnyObject) -> ModelWithId in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = ModelWithId()
                instance.id = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["id"])
                return instance
            }


            // Decoder for [NewsletterGet]
            Decoders.addDecoder(clazz: [NewsletterGet].self) { (source: AnyObject) -> [NewsletterGet] in
                return Decoders.decode(clazz: [NewsletterGet].self, source: source)
            }
            // Decoder for NewsletterGet
            Decoders.addDecoder(clazz: NewsletterGet.self) { (source: AnyObject) -> NewsletterGet in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = NewsletterGet()
                instance.listId = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["list_id"])
                instance.id = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["id"])
                instance.type = NewsletterGet.ModelType(rawValue: (sourceDictionary["type"] as? String) ?? "") 
                instance.name = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["name"])
                instance.description = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["description"])
                instance.hasOpenTracking = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["has_open_tracking"])
                instance.hasClickTracking = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["has_click_tracking"])
                instance.hasConversionTracking = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["has_conversion_tracking"])
                return instance
            }


            // Decoder for [NewsletterPost]
            Decoders.addDecoder(clazz: [NewsletterPost].self) { (source: AnyObject) -> [NewsletterPost] in
                return Decoders.decode(clazz: [NewsletterPost].self, source: source)
            }
            // Decoder for NewsletterPost
            Decoders.addDecoder(clazz: NewsletterPost.self) { (source: AnyObject) -> NewsletterPost in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = NewsletterPost()
                instance.type = NewsletterPost.ModelType(rawValue: (sourceDictionary["type"] as? String) ?? "") 
                instance.name = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["name"])
                instance.description = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["description"])
                instance.hasOpenTracking = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["has_open_tracking"])
                instance.hasClickTracking = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["has_click_tracking"])
                instance.hasConversionTracking = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["has_conversion_tracking"])
                instance.json = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["json"])
                instance.html = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["html"])
                instance.text = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["text"])
                instance.subject = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["subject"])
                instance.preheader = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["preheader"])
                instance.headerReplyEmail = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["header_reply_email"])
                instance.headerReplyName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["header_reply_name"])
                instance.headerFromEmail = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["header_from_email"])
                instance.headerFromName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["header_from_name"])
                return instance
            }


            // Decoder for [NewsletterResponse]
            Decoders.addDecoder(clazz: [NewsletterResponse].self) { (source: AnyObject) -> [NewsletterResponse] in
                return Decoders.decode(clazz: [NewsletterResponse].self, source: source)
            }
            // Decoder for NewsletterResponse
            Decoders.addDecoder(clazz: NewsletterResponse.self) { (source: AnyObject) -> NewsletterResponse in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = NewsletterResponse()
                instance.info = Decoders.decodeOptional(clazz: Info.self, source: sourceDictionary["info"])
                instance.value = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["value"])
                return instance
            }


            // Decoder for [NewsletterSend]
            Decoders.addDecoder(clazz: [NewsletterSend].self) { (source: AnyObject) -> [NewsletterSend] in
                return Decoders.decode(clazz: [NewsletterSend].self, source: source)
            }
            // Decoder for NewsletterSend
            Decoders.addDecoder(clazz: NewsletterSend.self) { (source: AnyObject) -> NewsletterSend in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = NewsletterSend()
                instance.scheduled = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["scheduled"])
                instance.groupIds = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["group_ids"])
                instance.recipientIds = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["recipient_ids"])
                instance.contexts = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["contexts"])
                return instance
            }


            // Decoder for [PatchResponse]
            Decoders.addDecoder(clazz: [PatchResponse].self) { (source: AnyObject) -> [PatchResponse] in
                return Decoders.decode(clazz: [PatchResponse].self, source: source)
            }
            // Decoder for PatchResponse
            Decoders.addDecoder(clazz: PatchResponse.self) { (source: AnyObject) -> PatchResponse in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = PatchResponse()
                instance.info = Decoders.decodeOptional(clazz: Info.self, source: sourceDictionary["info"])
                return instance
            }


            // Decoder for [RecipientGet]
            Decoders.addDecoder(clazz: [RecipientGet].self) { (source: AnyObject) -> [RecipientGet] in
                return Decoders.decode(clazz: [RecipientGet].self, source: source)
            }
            // Decoder for RecipientGet
            Decoders.addDecoder(clazz: RecipientGet.self) { (source: AnyObject) -> RecipientGet in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = RecipientGet()
                instance.id = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["id"])
                instance.email = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["email"])
                instance.phone = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["phone"])
                instance.gender = RecipientGet.Gender(rawValue: (sourceDictionary["gender"] as? String) ?? "") 
                instance.firstName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["first_name"])
                instance.lastName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["last_name"])
                instance.isUnsubscribed = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["is_unsubscribed"])
                instance.isBlacklisted = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["is_blacklisted"])
                instance.customAttribute_ = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["_custom_attribute_"])
                instance.rating = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["rating"])
                instance.statisticMailsReceived = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["statistic_mails_received"])
                instance.statisticMailsOpened = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["statistic_mails_opened"])
                instance.statisticMailsUniqueOpened = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["statistic_mails_unique_opened"])
                instance.statisticMailsClicked = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["statistic_mails_clicked"])
                instance.statisticConversions = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["statistic_conversions"])
                instance.statisticConversionsSum = Decoders.decodeOptional(clazz: Float.self, source: sourceDictionary["statistic_conversions_sum"])
                instance.statisticLastMailAction = Decoders.decodeOptional(clazz: NSDate.self, source: sourceDictionary["statistic_last_mail_action"])
                instance.statisticLastMailReceived = Decoders.decodeOptional(clazz: NSDate.self, source: sourceDictionary["statistic_last_mail_received"])
                instance.statisticLastMailOpened = Decoders.decodeOptional(clazz: NSDate.self, source: sourceDictionary["statistic_last_mail_opened"])
                instance.statisticLastMailClicked = Decoders.decodeOptional(clazz: NSDate.self, source: sourceDictionary["statistic_last_mail_clicked"])
                instance.statisticLastMailConverted = Decoders.decodeOptional(clazz: NSDate.self, source: sourceDictionary["statistic_last_mail_converted"])
                instance.statisticLastUseragentDevice = RecipientGet.StatisticLastUseragentDevice(rawValue: (sourceDictionary["statistic_last_useragent_device"] as? String) ?? "") 
                instance.statisticLastUseragentFamily = RecipientGet.StatisticLastUseragentFamily(rawValue: (sourceDictionary["statistic_last_useragent_family"] as? String) ?? "") 
                instance.statisticLastLatitude = Decoders.decodeOptional(clazz: Double.self, source: sourceDictionary["statistic_last_latitude"])
                instance.statisticLastLongitude = Decoders.decodeOptional(clazz: Double.self, source: sourceDictionary["statistic_last_longitude"])
                instance.statisticLastBlacklistList = Decoders.decodeOptional(clazz: NSDate.self, source: sourceDictionary["statistic_last_blacklist_list"])
                instance.statisticLastUnsubscribeList = Decoders.decodeOptional(clazz: NSDate.self, source: sourceDictionary["statistic_last_unsubscribe_list"])
                instance.statisticLastBlacklistListReason = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["statistic_last_blacklist_list_reason"])
                instance.statisticLastUnsubscribeListReason = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["statistic_last_unsubscribe_list_reason"])
                return instance
            }


            // Decoder for [RecipientPatch]
            Decoders.addDecoder(clazz: [RecipientPatch].self) { (source: AnyObject) -> [RecipientPatch] in
                return Decoders.decode(clazz: [RecipientPatch].self, source: source)
            }
            // Decoder for RecipientPatch
            Decoders.addDecoder(clazz: RecipientPatch.self) { (source: AnyObject) -> RecipientPatch in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = RecipientPatch()
                instance.email = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["email"])
                instance.phone = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["phone"])
                instance.gender = RecipientPatch.Gender(rawValue: (sourceDictionary["gender"] as? String) ?? "") 
                instance.firstName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["first_name"])
                instance.lastName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["last_name"])
                instance.isUnsubscribed = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["is_unsubscribed"])
                instance.isBlacklisted = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["is_blacklisted"])
                instance.customAttribute_ = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["_custom_attribute_"])
                return instance
            }


            // Decoder for [RecipientPost]
            Decoders.addDecoder(clazz: [RecipientPost].self) { (source: AnyObject) -> [RecipientPost] in
                return Decoders.decode(clazz: [RecipientPost].self, source: source)
            }
            // Decoder for RecipientPost
            Decoders.addDecoder(clazz: RecipientPost.self) { (source: AnyObject) -> RecipientPost in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = RecipientPost()
                instance.listId = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["list_id"])
                instance.email = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["email"])
                instance.phone = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["phone"])
                instance.gender = RecipientPost.Gender(rawValue: (sourceDictionary["gender"] as? String) ?? "") 
                instance.firstName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["first_name"])
                instance.lastName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["last_name"])
                instance.isUnsubscribed = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["is_unsubscribed"])
                instance.isBlacklisted = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["is_blacklisted"])
                instance.customAttribute_ = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["_custom_attribute_"])
                return instance
            }


            // Decoder for [RecipientResponse]
            Decoders.addDecoder(clazz: [RecipientResponse].self) { (source: AnyObject) -> [RecipientResponse] in
                return Decoders.decode(clazz: [RecipientResponse].self, source: source)
            }
            // Decoder for RecipientResponse
            Decoders.addDecoder(clazz: RecipientResponse.self) { (source: AnyObject) -> RecipientResponse in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = RecipientResponse()
                instance.info = Decoders.decodeOptional(clazz: Info.self, source: sourceDictionary["info"])
                instance.value = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["value"])
                return instance
            }


            // Decoder for [RecipientSimple]
            Decoders.addDecoder(clazz: [RecipientSimple].self) { (source: AnyObject) -> [RecipientSimple] in
                return Decoders.decode(clazz: [RecipientSimple].self, source: source)
            }
            // Decoder for RecipientSimple
            Decoders.addDecoder(clazz: RecipientSimple.self) { (source: AnyObject) -> RecipientSimple in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = RecipientSimple()
                instance.email = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["email"])
                instance.firstName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["first_name"])
                instance.lastName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["last_name"])
                return instance
            }


            // Decoder for [RecipientSubscribe]
            Decoders.addDecoder(clazz: [RecipientSubscribe].self) { (source: AnyObject) -> [RecipientSubscribe] in
                return Decoders.decode(clazz: [RecipientSubscribe].self, source: source)
            }
            // Decoder for RecipientSubscribe
            Decoders.addDecoder(clazz: RecipientSubscribe.self) { (source: AnyObject) -> RecipientSubscribe in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = RecipientSubscribe()
                instance.recipient = Decoders.decodeOptional(clazz: RecipientSubscribeRecipient.self, source: sourceDictionary["recipient"])
                return instance
            }


            // Decoder for [RecipientSubscribeRecipient]
            Decoders.addDecoder(clazz: [RecipientSubscribeRecipient].self) { (source: AnyObject) -> [RecipientSubscribeRecipient] in
                return Decoders.decode(clazz: [RecipientSubscribeRecipient].self, source: source)
            }
            // Decoder for RecipientSubscribeRecipient
            Decoders.addDecoder(clazz: RecipientSubscribeRecipient.self) { (source: AnyObject) -> RecipientSubscribeRecipient in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = RecipientSubscribeRecipient()
                instance.email = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["email"])
                instance.phone = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["phone"])
                instance.gender = RecipientSubscribeRecipient.Gender(rawValue: (sourceDictionary["gender"] as? String) ?? "") 
                instance.firstName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["first_name"])
                instance.lastName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["last_name"])
                instance.customAttribute_ = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["_custom_attribute_"])
                return instance
            }


            // Decoder for [RecipientSubscribeResponse]
            Decoders.addDecoder(clazz: [RecipientSubscribeResponse].self) { (source: AnyObject) -> [RecipientSubscribeResponse] in
                return Decoders.decode(clazz: [RecipientSubscribeResponse].self, source: source)
            }
            // Decoder for RecipientSubscribeResponse
            Decoders.addDecoder(clazz: RecipientSubscribeResponse.self) { (source: AnyObject) -> RecipientSubscribeResponse in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = RecipientSubscribeResponse()
                instance.info = Decoders.decodeOptional(clazz: Info.self, source: sourceDictionary["info"])
                instance.value = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["value"])
                return instance
            }


            // Decoder for [RecipientSubscribeResponseValue]
            Decoders.addDecoder(clazz: [RecipientSubscribeResponseValue].self) { (source: AnyObject) -> [RecipientSubscribeResponseValue] in
                return Decoders.decode(clazz: [RecipientSubscribeResponseValue].self, source: source)
            }
            // Decoder for RecipientSubscribeResponseValue
            Decoders.addDecoder(clazz: RecipientSubscribeResponseValue.self) { (source: AnyObject) -> RecipientSubscribeResponseValue in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = RecipientSubscribeResponseValue()
                instance.result = Decoders.decodeOptional(clazz: RecipientSubscribeResponseValueResult.self, source: sourceDictionary["result"])
                return instance
            }


            // Decoder for [RecipientSubscribeResponseValueResult]
            Decoders.addDecoder(clazz: [RecipientSubscribeResponseValueResult].self) { (source: AnyObject) -> [RecipientSubscribeResponseValueResult] in
                return Decoders.decode(clazz: [RecipientSubscribeResponseValueResult].self, source: source)
            }
            // Decoder for RecipientSubscribeResponseValueResult
            Decoders.addDecoder(clazz: RecipientSubscribeResponseValueResult.self) { (source: AnyObject) -> RecipientSubscribeResponseValueResult in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = RecipientSubscribeResponseValueResult()
                instance.success = Decoders.decodeOptional(clazz: RecipientSubscribeResponseValueResultSuccess.self, source: sourceDictionary["success"])
                instance.error = Decoders.decodeOptional(clazz: RecipientSubscribeResponseValueResultError.self, source: sourceDictionary["error"])
                return instance
            }


            // Decoder for [RecipientSubscribeResponseValueResultError]
            Decoders.addDecoder(clazz: [RecipientSubscribeResponseValueResultError].self) { (source: AnyObject) -> [RecipientSubscribeResponseValueResultError] in
                return Decoders.decode(clazz: [RecipientSubscribeResponseValueResultError].self, source: source)
            }
            // Decoder for RecipientSubscribeResponseValueResultError
            Decoders.addDecoder(clazz: RecipientSubscribeResponseValueResultError.self) { (source: AnyObject) -> RecipientSubscribeResponseValueResultError in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = RecipientSubscribeResponseValueResultError()
                instance.failed = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["failed"])
                instance.recipients = Decoders.decodeOptional(clazz: RecipientSubscribeResponseValueResultErrorRecipients.self, source: sourceDictionary["recipients"])
                return instance
            }


            // Decoder for [RecipientSubscribeResponseValueResultErrorRecipients]
            Decoders.addDecoder(clazz: [RecipientSubscribeResponseValueResultErrorRecipients].self) { (source: AnyObject) -> [RecipientSubscribeResponseValueResultErrorRecipients] in
                return Decoders.decode(clazz: [RecipientSubscribeResponseValueResultErrorRecipients].self, source: source)
            }
            // Decoder for RecipientSubscribeResponseValueResultErrorRecipients
            Decoders.addDecoder(clazz: RecipientSubscribeResponseValueResultErrorRecipients.self) { (source: AnyObject) -> RecipientSubscribeResponseValueResultErrorRecipients in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = RecipientSubscribeResponseValueResultErrorRecipients()
                instance.duplicate = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["duplicate"])
                instance.invalid = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["invalid"])
                return instance
            }


            // Decoder for [RecipientSubscribeResponseValueResultSuccess]
            Decoders.addDecoder(clazz: [RecipientSubscribeResponseValueResultSuccess].self) { (source: AnyObject) -> [RecipientSubscribeResponseValueResultSuccess] in
                return Decoders.decode(clazz: [RecipientSubscribeResponseValueResultSuccess].self, source: source)
            }
            // Decoder for RecipientSubscribeResponseValueResultSuccess
            Decoders.addDecoder(clazz: RecipientSubscribeResponseValueResultSuccess.self) { (source: AnyObject) -> RecipientSubscribeResponseValueResultSuccess in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = RecipientSubscribeResponseValueResultSuccess()
                instance.inserted = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["inserted"])
                return instance
            }


            // Decoder for [Report]
            Decoders.addDecoder(clazz: [Report].self) { (source: AnyObject) -> [Report] in
                return Decoders.decode(clazz: [Report].self, source: source)
            }
            // Decoder for Report
            Decoders.addDecoder(clazz: Report.self) { (source: AnyObject) -> Report in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = Report()
                instance.newsletterId = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["newsletter_id"])
                instance.date = Decoders.decodeOptional(clazz: NSDate.self, source: sourceDictionary["date"])
                instance.mailCount = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["mail_count"])
                instance.opens = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["opens"])
                instance.uniqueOpens = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["unique_opens"])
                instance.clicks = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["clicks"])
                instance.uniqueClicks = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["unique_clicks"])
                instance.conversions = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["conversions"])
                instance.sumConversions = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["sum_conversions"])
                instance.unsubscribes = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["unsubscribes"])
                instance.hardBounces = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["hard_bounces"])
                instance.softBounces = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["soft_bounces"])
                instance.spamBounces = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["spam_bounces"])
                return instance
            }


            // Decoder for [ReportResponse]
            Decoders.addDecoder(clazz: [ReportResponse].self) { (source: AnyObject) -> [ReportResponse] in
                return Decoders.decode(clazz: [ReportResponse].self, source: source)
            }
            // Decoder for ReportResponse
            Decoders.addDecoder(clazz: ReportResponse.self) { (source: AnyObject) -> ReportResponse in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = ReportResponse()
                instance.info = Decoders.decodeOptional(clazz: Info.self, source: sourceDictionary["info"])
                instance.value = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["value"])
                return instance
            }


            // Decoder for [Token]
            Decoders.addDecoder(clazz: [Token].self) { (source: AnyObject) -> [Token] in
                return Decoders.decode(clazz: [Token].self, source: source)
            }
            // Decoder for Token
            Decoders.addDecoder(clazz: Token.self) { (source: AnyObject) -> Token in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = Token()
                instance.accessToken = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["access_token"])
                instance.expiresIn = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["expires_in"])
                instance.tokenType = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["token_type"])
                instance.refreshToken = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["refresh_token"])
                return instance
            }


            // Decoder for [UserGet]
            Decoders.addDecoder(clazz: [UserGet].self) { (source: AnyObject) -> [UserGet] in
                return Decoders.decode(clazz: [UserGet].self, source: source)
            }
            // Decoder for UserGet
            Decoders.addDecoder(clazz: UserGet.self) { (source: AnyObject) -> UserGet in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = UserGet()
                instance.id = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["id"])
                instance.email = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["email"])
                instance.firstName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["first_name"])
                instance.lastName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["last_name"])
                instance.gender = UserGet.Gender(rawValue: (sourceDictionary["gender"] as? String) ?? "") 
                instance.isActive = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["is_active"])
                return instance
            }


            // Decoder for [UserPatch]
            Decoders.addDecoder(clazz: [UserPatch].self) { (source: AnyObject) -> [UserPatch] in
                return Decoders.decode(clazz: [UserPatch].self, source: source)
            }
            // Decoder for UserPatch
            Decoders.addDecoder(clazz: UserPatch.self) { (source: AnyObject) -> UserPatch in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = UserPatch()
                instance.email = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["email"])
                instance.firstName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["first_name"])
                instance.lastName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["last_name"])
                instance.gender = UserPatch.Gender(rawValue: (sourceDictionary["gender"] as? String) ?? "") 
                return instance
            }


            // Decoder for [UserResponse]
            Decoders.addDecoder(clazz: [UserResponse].self) { (source: AnyObject) -> [UserResponse] in
                return Decoders.decode(clazz: [UserResponse].self, source: source)
            }
            // Decoder for UserResponse
            Decoders.addDecoder(clazz: UserResponse.self) { (source: AnyObject) -> UserResponse in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = UserResponse()
                instance.info = Decoders.decodeOptional(clazz: Info.self, source: sourceDictionary["info"])
                instance.value = Decoders.decodeOptional(clazz: Array.self, source: sourceDictionary["value"])
                return instance
            }
        }
    }
}
